import json

def generateheader(widthStr,heightStr):
    format_byte_14 = str(2 * int(widthStr))
    lenof14 = True
    while(lenof14):
        if(len(format_byte_14)<3):
            format_byte_14 = '0' + format_byte_14
        else:
            lenof14 = False
    
    h = "\\"+widthStr+"\\000\\000\\000\\"+heightStr+"\\000\\000\\000\\000\\000\\000\\000\\"+format_byte_14+"\\000\\000\\000\\016\\000\\001\\000"

    return h

def reqfile():
    name = input("Enter the name of the Json file:")

    if(name[-5:] != ".json"):
        name = name + ".json"

    return name

name = reqfile()
with open(name) as file:
    row = -1
    column = 0
    final = ''
    
    jsonfile = json.load(file)
    width = int(jsonfile['width'],10)
    height = int(jsonfile['height'],10)

    widthStr = jsonfile['width']
    heightStr = jsonfile['height']

    formataxislen = True
    done = False
    
    while(formataxislen):
        if len(widthStr) < 3:
            widthStr = '0' + widthStr
        elif len(heightStr) < 3:
            heightStr = '0' + heightStr
        if(len(widthStr)==3 and len(heightStr)==3):
            formataxislen = False

    header = generateheader(widthStr,heightStr)
    
    while(not done):
        if(row <= width-1 and column <= height-1):
            if(row < width-1):
                row+=1
            elif(row == width-1 and column < height-1):
                row = 0
                column+=1
            elif(column == height-1):
                read = False
                done = True

        setlen = True
        lenofch = True
        rowStr = str(row)

        sel = jsonfile['column'][column][rowStr]

        a = sel[0]
        r = str(bin(int((int(sel[1:4],10))*31/255)))[2:]
        g = str(bin(int((int(sel[4:7],10))*31/255)))[2:]
        b = str(bin(int((int(sel[7:],10))*31/255)))[2:]
        
        while(setlen):
            if(len(r) < 5):
                r = '0' + r
            elif(len(g) < 5):
                g = '0' + g
            elif(len(b) < 5):
                b = '0' + b
            elif(len(r)==5 and len(g)==5 and len(b)==5):
                setlen = False

        ch1 = str(int((a+r+g+b)[8:],2))
        ch2 = str(int((a+r+g+b)[:8],2))

        while(lenofch):
            if(len(ch1) < 3):
                ch1 = '0' + ch1
            elif(len(ch2) < 3):
                ch2 = '0' + ch2
            elif(len(ch1) == 3 and len(ch2) == 3):
                lenofch = False

        final = final + '\\' +ch1+ '\\' + ch2


of = name + '.newimage'
with open(of,'w') as outfile:
    final = header + final
    outfile.write(final)
